/* 
TPWC AI SUPPRESSION 

Authors: TPW & -Coulum- 
1.01 20120625
*/ 

//////////// 
//VARIABLES 
/////////// 

//Suppression mode. 1 = basic , 2 = light, 3 = full stance / skills modification    
tpwc_ai_sup_mode = 3;   

//Delay before suppression functions start. Allows time for other AI mods to set unit skills 
tpwc_ai_sup_sleep = 5; 

//Debugging. Will display red balls over any suppressed units. 0 = no debugging, 1 = debugging 
tpwc_ai_sup_debug = 1; 

//Bullet detection radius (m). Bullets must pass within this distance of unit to suppress them. If set much below 10m, bullets may not be detected 
tpwc_ai_sup_br = 10; 

//Bullet ignore radius (m). Bullets from a shooter closer than this will not suppress.  
tpwc_ai_sup_ir = 25; 

//Shot threshold. More shots than this will cause unit to drop/crawl 
tpwc_ai_sup_st = 5; 

//Startup hint. 0 = no hint, 1 = hint 
tpwc_ai_sup_hint = 1;  

//Pistol and SMG ammo to ignore. Add custom ammo (eg suppressed) or change to taste     
tpwc_ai_sup_mags =[ 
"30rnd_9x19_MP5",    
"30rnd_9x19_MP5SD",    
"15Rnd_9x19_M9",    
"15Rnd_9x19_M9SD",    
"7Rnd_45ACP_1911",    
"7Rnd_45ACP_1911",   
"8Rnd_9x18_Makarov",   
"8Rnd_9x18_MakarovSD",   
"64Rnd_9x19_Bizon",   
"64Rnd_9x19_SD_Bizon",   
"13Rnd_9mm_SLP",   
"17Rnd_9x19_glock17",   
"6Rnd_45ACP",   
"30Rnd_9x19_UZI",   
"30Rnd_9x19_UZI_SD" 
];   

////////// 
// SET UP 
////////// 

//Declare private variables 
private ["_stanceregain","_skillregain","_unit","_bc","_shots","_originalaccuracy","_originalshake","_originalcourage","_general","_ball","_skillset","_asr"];  

//Allow time for ASR AI skills to propagate 
sleep tpwc_ai_sup_sleep; 

//Start hint    
if (tpwc_ai_sup_hint == 1) then { 
0 = [] spawn {sleep 3; hintsilent "TPWC AI Suppress 1.01 Active"; sleep 3; hintsilent ""}; 
};    


////////////////// 
// MAIN FUNCTIONS  
//////////////////  

//Basic version 
tpwc_ai_sup_basic =     
{   
    {   
    if (alive _x) then    
        { 
        _unit = _x;      
        _stanceregain = _unit getvariable ["tpwc_stanceregain", -1];  

        if (_stanceregain == -1) then    
            {      
            _unit setvariable ["tpwc_stanceregain", diag_ticktime];  
            _unit addeventhandler ["fired",{tpwc_ai_sup_fired = _this select 0;tpwc_ai_sup_bullet = _this select 6}];   
            _ball = "Sign_sphere25cm_EP1" createvehicle getposatl _unit;_ball attachTo [_unit,[0,0,2]]; _unit setvariable ["tpwc_supball",_ball]; 
            };  
      
        if ( diag_ticktime >= _stanceregain) then    
            {  
            _ball = _unit getvariable "tpwc_supball"; _ball hideobject true;          
            _unit setvariable ["tpwc_supshots", 0];   
            _unit setunitpos "auto";  
			_unit setvariable ["tpwc_suppressedstance", 0]; 
            _unit setvariable ["tpwc_stanceregain", diag_ticktime + 10];  
            };  

        if !(isnull tpwc_ai_sup_bullet) then    
            {   
            _bc = count ((getposatl _unit) nearobjects ["bulletbase",tpwc_ai_sup_br]);   
            if (_bc > 0) then    
                {  
                if ((tpwc_ai_sup_fired distance _unit) > tpwc_ai_sup_ir) then    
                    {   
                    _unit setvariable ["tpwc_stanceregain", diag_ticktime + 10];   
                    _shots = _unit getvariable "tpwc_supshots";   
                    _unit setvariable ["tpwc_supshots", _shots + _bc];   
                    _shots = _unit getvariable "tpwc_supshots";  
                    _unit setunitpos "middle"; 
					_unit setvariable ["tpwc_suppressedstance", 1]; 
                    if (tpwc_ai_sup_debug == 1) then  
                        { 
                        _ball = _unit getvariable "tpwc_supball";_ball hideobject false; 
                        };             
                    if (_shots > tpwc_ai_sup_st) then   
                        {  
                        _unit setunitpos "down";  
                        };   
                    };   
                };   
            };   
        };    
    } foreach allunits;   
};   

//Lite version 
tpwc_ai_sup_ai_sup_lite =     
{    
    {   
    if (alive _x) then    
        { 
        _unit = _x;      
        _stanceregain = _unit getvariable ["tpwc_stanceregain", -1];  

        if (_stanceregain == -1) then    
            {      
            _unit setvariable ["tpwc_stanceregain", diag_ticktime];  
            _unit addeventhandler ["fired",{tpwc_ai_sup_fired = _this select 0;tpwc_ai_sup_mag = _this select 5; tpwc_ai_sup_bullet = _this select 6}];   
            _ball = "Sign_sphere25cm_EP1" createvehicle getposatl _unit;_ball attachTo [_unit,[0,0,2]]; _unit setvariable ["tpwc_supball",_ball]; 
            };  
      
        if ( diag_ticktime >= _stanceregain) then    
            {  
            _ball = _unit getvariable "tpwc_supball"; _ball hideobject true;              
            _unit setvariable ["tpwc_supshots", 0];   
            _unit setunitpos "auto";  
			_unit setvariable ["tpwc_suppressedstance", 0]; 
            _unit setvariable ["tpwc_stanceregain", diag_ticktime + 10];  
            };  

        if !(isnull tpwc_ai_sup_bullet) then    
            {   
            _bc = count ((getposatl _unit) nearobjects ["bulletbase",tpwc_ai_sup_br]);   
            if (_bc > 0) then    
                {  
                if ((tpwc_ai_sup_fired distance _unit) > tpwc_ai_sup_ir) then    
                    {   
                    if !(tpwc_ai_sup_mag in tpwc_ai_sup_mags) then    
                        {  
                        _unit setvariable ["tpwc_stanceregain", diag_ticktime + 10];   
                        _shots = _unit getvariable "tpwc_supshots";   
                        _unit setvariable ["tpwc_supshots", _shots + _bc];   
                        _unit setunitpos "middle"; 
						_unit setvariable ["tpwc_suppressedstance", 1]; 						
                        if ((side tpwc_ai_sup_fired != side _unit) && (vehicle _unit == _unit)) then    
                            { 
                            _shots = _unit getvariable "tpwc_supshots";  
                            if (tpwc_ai_sup_debug == 1) then  
                                { 
                                _ball = _unit getvariable "tpwc_supball";_ball hideobject false; 
                                }; 
                            if (_shots > tpwc_ai_sup_st) then   
                                {  
                                _unit setunitpos "down";  
                                };   
                            };    
                        };   
                    };   
                };   
            };   
        };    
    } foreach allunits;   
};   

tpwc_ai_sup_full =      
{     
    {    
    if (alive _x) then     
        {  
        _unit = _x;       
        _skillregain = _unit getvariable ["tpwc_skillregain", -1];     
        _stanceregain = _unit getvariable ["tpwc_stanceregain", -1];   

        if (_stanceregain == -1) then     
             { 
             _unit setvariable ["asr_ai_sys_aiskill_configured", false];  
             _unit setvariable ["tpwc_skillset", false];  
			 _unit setvariable ["tpwc_combatmode", "unchanged"]; 
            _unit setvariable ["tpwc_originalaccuracy", _unit skill "aimingaccuracy"];   
            _unit setvariable ["tpwc_originalshake",  _unit skill "aimingshake"];  
            _unit setvariable ["tpwc_originalcourage", _unit skill "courage"];   
            _unit setvariable ["tpwc_general", _unit skill "general"];  
            _unit setvariable ["tpwc_stanceregain", diag_ticktime];   
            _unit setvariable ["tpwc_skillregain", diag_ticktime];     
            _unit addeventhandler ["fired",{tpwc_ai_sup_fired = _this select 0;tpwc_ai_sup_mag = _this select 5; tpwc_ai_sup_bullet = _this select 6}];    
            _ball = "Sign_sphere25cm_EP1" createvehicle getposatl _unit;_ball attachTo [_unit,[0,0,2]]; _unit setvariable ["tpwc_supball",_ball];  
            };   
       
        if ( diag_ticktime >= _stanceregain) then     
            {   
            _ball = _unit getvariable "tpwc_supball"; _ball hideobject true;          
            _unit setvariable ["tpwc_supshots", 0];    
            _unit setunitpos "auto";   
			_originalcourage = _unit getvariable "tpwc_originalcourage";   
            _general = _unit getvariable "tpwc_general";
			_unit setvariable ["tpwc_suppressedstance", 0]; 			
            if((_unit skill "courage") < (_originalcourage - 0.1)) then    
                {    
                _unit setskill ["courage",(_unit skill "courage")+(_general)*(0.003)];     
                }   
                else  
                {  
				if (_unit getvariable "tpwc_combatmode" != "unchanged") then 
					{
					_unit setbehaviour str(_unit getvariable "tpwc_combatmode");
					_unit setvariable ["tpwc_combatmode", "unchanged"]; 
					};
				_unit setvariable ["tpwc_stanceregain", diag_ticktime + 10];       
                };  
            };   
   
        if (diag_ticktime >= _skillregain) then    
            {  
            _originalaccuracy = _unit getvariable "tpwc_originalaccuracy";      
            _originalshake = _unit getvariable "tpwc_originalshake";               
            _originalcourage = _unit getvariable "tpwc_originalcourage";   
            _general = _unit getvariable "tpwc_general";         
            if((_unit skill "aimingaccuracy") < _originalaccuracy) then    
                {  
                _unit setskill ["aimingaccuracy",(_unit skill "aimingaccuracy")+((_originalaccuracy-(_unit skill "aimingaccuracy"))*.01)];     
                };   
            if((_unit skill "aimingshake") < _originalshake) then    
                {    
                _unit setskill ["aimingshake",(_unit skill "aimingshake")+((_originalshake-(_unit skill "aimingshake"))*.01)];    
                };  
            if (((_unit skill "aimingshake") > (_originalshake - 0.1)) && ((_unit skill "aimingaccuracy") > (_originalaccuracy - 0.1))) then   
                {  
                _unit setvariable ["tpwc_skillregain", diag_ticktime + 10];  
                }  
            };   

        if !(isnull tpwc_ai_sup_bullet) then     
            {    
            _bc = count ((getposatl _unit) nearobjects ["bulletbase",tpwc_ai_sup_br]);    
            if (_bc > 0) then     
                {   
                if ((tpwc_ai_sup_fired distance _unit) > tpwc_ai_sup_ir) then     
                    {    
                    if !(tpwc_ai_sup_mag in tpwc_ai_sup_mags) then     
                        {   
                        _unit setvariable ["tpwc_skillregain", diag_ticktime + (random 4)-((_unit getvariable "tpwc_general")+(_unit getvariable "tpwc_originalcourage"))];     
                        _unit setvariable ["tpwc_stanceregain", diag_ticktime + 10];    
                        _shots = _unit getvariable "tpwc_supshots";    
                        _unit setvariable ["tpwc_supshots", _shots + _bc];    
                        _unit setunitpos "middle";    
						_unit setvariable ["tpwc_suppressedstance", 1]; 	
                        if ((side tpwc_ai_sup_fired != side _unit) && (vehicle _unit == _unit)) then
							{
                            _unit setvariable ["tpwc_combatmode", behaviour _unit]; 
							_unit setbehaviour "COMBAT";	
                            _shots = _unit getvariable "tpwc_supshots";   
                            _originalaccuracy = _unit getvariable "tpwc_originalaccuracy";     
                            _originalshake = _unit getvariable "tpwc_originalshake";   
                            _originalcourage = _unit getvariable "tpwc_originalcourage";    
                            _general = _unit getvariable "tpwc_general";  
                            _unit setskill ["aimingaccuracy",_originalaccuracy*_originalcourage*_general-(_shots*(1-_general)*.003)];    
                            _unit setskill ["aimingshake",_originalshake*_originalcourage*_general-(_shots*(1-_general)*.003)];   
                            _unit setskill ["courage",_originalcourage*_originalcourage*_general-(_shots*(1-_general)*.003)];  
                            if (tpwc_ai_sup_debug == 1) then   
                                {  
                                _ball = _unit getvariable "tpwc_supball";_ball hideobject false;  
                                };                          
                            if (_shots > tpwc_ai_sup_st) then    
                                {   
                                _unit setunitpos "down";   
                                };    
                            };     
                        };    
                    };    
                };    
            };    
        };     
    } foreach allunits;    
};    

//If ASR AI has set unit skills, make these the "originals" for each unit  
tpwc_ai_sup_asrskills = 
{ 
sleep 3; 
while {true} do  
    { 
        { 
        _unit = _x; 
        _asr = _unit getVariable "asr_ai_sys_aiskill_configured"; 
        _skillset = _unit getVariable "tpwc_skillset"; 
        if ((_asr) && !(_skillset))then  
            { 
            _unit setvariable ["tpwc_originalaccuracy", _unit skill "aimingaccuracy"];   
            _unit setvariable ["tpwc_originalshake", _unit skill "aimingshake"];  
            _unit setvariable ["tpwc_originalcourage", _unit skill "courage"];   
            _unit setvariable ["tpwc_general",_unit skill "general"];  
            _unit setvariable ["tpwc_skillset", true]; 
            }; 
        } foreach allunits; 
    sleep 30; 
    }; 
};  

//CALL APPROPRIATE FUNCTION USING PER FRAME EVENTHANDLER 
if (tpwc_ai_sup_mode == 1) then  
    { 
    [tpwc_ai_sup_basic,0] call cba_fnc_addPerFrameHandler; 
    };   
if (tpwc_ai_sup_mode == 2) then  
    { 
    [tpwc_ai_sup_lite,0] call cba_fnc_addPerFrameHandler; 
    };  
if (tpwc_ai_sup_mode == 3) then  
    {
	//Spawn ASR_AI skill set loop if running ASR_AI > 1.15.1 	
    if (isclass (configfile >> "cfgPatches">>"asr_ai_sys_aiskill")) then  
        { 
		_asr_ai_va = getArray (configfile>>"cfgPatches">>"asr_ai_main">>"versionAr");
		if (_asr_ai_va select 0 >= 1 && _asr_ai_va select 1 >= 15 && _asr_ai_va select 2 >= 1) then 
			{
			[] spawn tpwc_ai_sup_asrskills; 
			};	
		}; 
    [tpwc_ai_sup_full,0] call cba_fnc_addPerFrameHandler;  
    }; 